package com.huiju.estateagents.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.estateagents.center.taUser.entity.TaUser;
import com.huiju.estateagents.center.taUser.mapper.TaUserMapper;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.estateagents.common.CommConstant;
import com.huiju.estateagents.common.StringUtils;
import com.huiju.estateagents.drainage.entity.TaDrainage;
import com.huiju.estateagents.drainage.mapper.TaDrainageMapper;
import com.huiju.estateagents.entity.*;
import com.huiju.estateagents.mapper.HelpActivityMapper;
import com.huiju.estateagents.mapper.TaBuildingDynamicMapper;
import com.huiju.estateagents.mapper.TaNewsMapper;
import com.huiju.estateagents.mapper.TaPersonMapper;
import com.huiju.estateagents.mapper.TaPersonVisitRecordMapper;
import com.huiju.estateagents.mapper.TaRecommendCustomerMapper;
import com.huiju.estateagents.mapper.TaShareActivityMapper;
import com.huiju.estateagents.service.ITaPersonVisitRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collections;
import java.util.List;

/**
 * <p>
 *   服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-07-23
 */
@Service
public class TaPersonVisitRecordServiceImpl extends ServiceImpl<TaPersonVisitRecordMapper, TaPersonVisitRecord> implements ITaPersonVisitRecordService {
	
	@Autowired
	private TaRecommendCustomerMapper taRecommendCustomerMapper;
	
	@Autowired
	private TaPersonVisitRecordMapper personVisitRecordMapper;
	
	@Autowired
	private TaBuildingDynamicMapper taBuildingDynamicMapper;
	
	@Autowired
	private TaShareActivityMapper taShareActivityMapper;
	
	@Autowired
	private HelpActivityMapper helpActivityMapper;
	
	@Autowired
	private TaNewsMapper taNewsMapper;

	@Autowired
	private TaUserMapper taUserMapper;

	@Autowired
	private TaPersonMapper taPersonMapper;

	@Autowired
	private TaDrainageMapper taDrainageMapper;

	/**
	 * 分页获取客户访问记录
	 *
	 * @param pg
	 * @param customerId
	 * @return
	 */
	@Override
	public IPage<TaPersonVisitRecord> getPersonVisitRecordList(IPage<TaPersonVisitRecord> pg, String customerId) {
		TaRecommendCustomer taRecommendCustomer = taRecommendCustomerMapper.selectById(customerId);
		IPage<TaPersonVisitRecord> result = personVisitRecordMapper.getPersonVisitRecordList(pg,taRecommendCustomer.getPersonId());
		List<TaPersonVisitRecord> records = result.getRecords();
		records.forEach(e -> {
			//获取活动标题
			if ("activity".equals(e.getEventType()) && null != e.getTargetId()){
				TaBuildingDynamic taBuildingDynamic = taBuildingDynamicMapper.selectById(e.getTargetId());
				if (null != taBuildingDynamic){
					e.setActivityName(taBuildingDynamic.getTitle());
				}
				
			}
			//获取拼团标题
			if ("group".equals(e.getEventType()) && null != e.getTargetId()){
				TaShareActivity taShareActivity = taShareActivityMapper.selectById(e.getTargetId());
				if (null != taShareActivity){
					e.setActivityName(taShareActivity.getActivityName());
				}
			}
			//获取助力标题
			if ("help".equals(e.getEventType()) && null != e.getTargetId()){
				HelpActivity helpActivity = helpActivityMapper.selectById(e.getTargetId());
				if (null != helpActivity){
					e.setActivityName(helpActivity.getTitle());
				}
			}
			//获取咨询标题
			if ("news".equals(e.getEventType()) && null != e.getTargetId()){
				TaNews taNews = taNewsMapper.selectById(e.getTargetId());
				if (null != taNews){
					e.setActivityName(taNews.getNewsName());
				}
			}
			//获取H5活动标题
			if ("h5".equals(e.getEventType()) && null != e.getTargetId()){
				TaDrainage taDrainage = taDrainageMapper.selectById(e.getTargetId());
				if (null != taDrainage){
					e.setActivityName(taDrainage.getName());
				}
			}
		});
		result.setRecords(records);
		return result;
	}

	@Override
	public IPage<TaPersonVisitRecord> getDrainageVisitRecord(IPage<TaPersonVisitRecord> pg, Integer orgId, String activityName, String eventType, String shareName, String shareTel, String buildingId, String personType, List<TaPersonBuilding> taPersonBuildingList) {
		IPage<TaPersonVisitRecord> taPersonVisitRecordIPage = personVisitRecordMapper.getDrainageVisitRecord(pg, orgId, activityName, eventType, shareName, shareTel, buildingId, personType, taPersonBuildingList);
		List<TaPersonVisitRecord> taPersonVisitRecords = taPersonVisitRecordIPage.getRecords();
		for (TaPersonVisitRecord e : taPersonVisitRecords) {

			TaPerson personInfo = taPersonMapper.selectById(e.getPersonId());
			if (personInfo != null) {
				e.setUserName(personInfo.getNickname());
				e.setUserTel(personInfo.getPhone());
			}

			TaPerson userShareInfo = taPersonMapper.selectById(e.getPersonId());
			if (userShareInfo != null) {
				e.setShareName(userShareInfo.getNickname());
				e.setShareTel(userShareInfo.getPhone());
			}

			if (CommConstant.EVENT_H5.equals(e.getEventType())) {
				e.setActivityName(e.getDrainageName());
				continue;
			}
			if (CommConstant.POSTER_CONTENT_TYPE_BUILDING.equals(e.getEventType())) {
				e.setActivityName(e.getBuildingName());
				continue;
			}
			if (CommConstant.POSTER_CONTENT_TYPE_NEWS.equals(e.getEventType())) {
				e.setActivityName(e.getNewsName());
				continue;
			}
			if (CommConstant.POINTS_CHANGE_HELP.equals(e.getEventType())) {
				e.setActivityName(e.getHelpActivityName());
				continue;
			}
			if (CommConstant.POINTS_CHANGE_GROUP.equals(e.getEventType())) {
				e.setActivityName(e.getGroupActivityName());
				continue;
			}
		}
		taPersonVisitRecordIPage.setRecords(taPersonVisitRecords);
		return taPersonVisitRecordIPage;
	}

	@Override
	public IPage<TaConsultantInfo> getConsultantShareInfoList(IPage<TaConsultantInfo> pg, String personId) {
		IPage<TaConsultantInfo> result = personVisitRecordMapper.getConsultantShareInfoList(pg,personId);
		return result;
	}

	@Override
	public Integer countShareNumByEventType(Integer orgId, String targetId, Integer userId, String eventType) {
		return personVisitRecordMapper.countShareNumByEventType(orgId, targetId, userId, eventType);
	}

	/**
	 * 分页获取个人中心访客记录
	 *
	 * @param pg
	 * @param userId
	 * @param orgId
	 * @return
	 */
	@Override
	public IPage<TaPersonVisitRecord> getWxVisitRecordList(IPage<TaPersonVisitRecord> pg, Integer userId, Integer orgId) {
		//根据userId获取用户信息
		QueryWrapper<TaPerson> taPersonQueryWrapper = new QueryWrapper<>();
		taPersonQueryWrapper.eq("user_id",userId);
		taPersonQueryWrapper.eq("org_id",orgId);
		TaPerson taPerson = taPersonMapper.selectOne(taPersonQueryWrapper);
		//获取我的访问客户列表
		IPage<TaPersonVisitRecord> result = personVisitRecordMapper.getWxVisitRecordList(pg,userId,orgId, CommConstant.EVENT_H5,taPerson.getPersonId());
		List<TaPersonVisitRecord> records = result.getRecords();
		//判断是否我的客户状态
		records.forEach(e -> {
			QueryWrapper<TaRecommendCustomer> queryWrapper = new QueryWrapper();
			queryWrapper.eq("realty_consultant",e.getConsultantId());
			queryWrapper.eq("person_id",e.getPersonId());
			TaRecommendCustomer taRecommendCustomer = taRecommendCustomerMapper.selectOne(queryWrapper);
			if (null != taRecommendCustomer){
				//1是我的客户
				e.setMyCustomer(CommConstant.STATUS_NORMAL);
			}
		});
		return result;
	}


	/**
	 * 分页获取个人中心访客记录
	 *
	 * @param pg
	 * @param userId
	 * @param orgId
	 * @return
	 */
	@Override
	public IPage<TaPersonVisitRecord> getWxActivityVisitRecordList(IPage<TaPersonVisitRecord> pg, Integer userId, Integer orgId, String targetId, String eventType) {
		//根据userId获取用户信息
		QueryWrapper<TaPerson> taPersonQueryWrapper = new QueryWrapper<>();
		taPersonQueryWrapper.eq("user_id",userId);
		taPersonQueryWrapper.eq("org_id",orgId);
		TaPerson taPerson = taPersonMapper.selectOne(taPersonQueryWrapper);
		//获取我的访问客户列表
		IPage<TaPersonVisitRecord> result = personVisitRecordMapper.getWxActivityVisitRecordList(pg,userId,orgId, targetId,taPerson.getPersonId(), (CommConstant.FAVOR_PROJECT.equals(eventType) ? "building" : CommConstant.FAVOR_ACTIVITY.equals(eventType) ? "dynamic" : eventType)  + "_share");
		List<TaPersonVisitRecord> records = result.getRecords();
		//判断是否我的客户状态
		records.forEach(e -> {
			QueryWrapper<TaRecommendCustomer> queryWrapper = new QueryWrapper();
			queryWrapper.eq("realty_consultant",e.getConsultantId());
			queryWrapper.eq("person_id",e.getPersonId());
			List<TaRecommendCustomer> taRecommendCustomers = taRecommendCustomerMapper.selectList(queryWrapper);
			if (taRecommendCustomers.size() > 0){
				//1是我的客户
				e.setMyCustomer(CommConstant.STATUS_NORMAL);
				//返回customer_id给微信端
				e.setCustomerId(taRecommendCustomers.get(0).getCustomerId());
			}
		});
		return result;
	}

	/**
	 * 获取这个人的活动数据列表
	 *
	 * @param userId
	 * @param personId
	 * @param orgId
	 * @return
	 */
	@Override
	public IPage<TaPersonVisitRecord> getWxVisitRecordActivityList(IPage<TaPersonVisitRecord> pg,Integer userId, String personId, Integer orgId) {
		return personVisitRecordMapper.getWxVisitRecordActivityList(pg,userId,personId,orgId,CommConstant.EVENT_H5);
	}

//    @Autowired
//    private TaPersonMapper taPersonMapper;
//    @Autowired
//    private TaPersonVisitRecordMapper taPersonVisitRecordMapper;
//
//    @Override
//    public IPage<TaPerson> selectCustomer(IPage<TaPerson> page){
//        return taPersonMapper.selectCustomer(page);
//    }
//
//    @Override
//    public TaPerson customerInfo(String personId,String consultentId){
//        TaPerson taPerson = taPersonMapper.selectById(personId);
//        taPerson.setVisitRecords(taPersonVisitRecordMapper.visitRecordByPersonId(personId));
//        return taPerson;
//    }



}
